#pragma once
#include "ifdefs.h"
#include "movingsprite.h"

#ifndef ANIMATEDSPRITE_H
#define ANIMATEDSPRITE_H

#define MAX_FRAMES 50
#define MAX_ANIMATIONS 20

// Clase AnimatedSprite
class AnimatedSprite : public MovingSprite
{
public:
    // Constructor
    AnimatedSprite();

    // Destructor
    ~AnimatedSprite();

    // Iniciador
    void init(LTexture *texture, SDL_Renderer *renderer);

    // Calcula el frame correspondiente a la animación
    void animate(int index);

    // Actualiza todas las variables del objeto: posición, velocidad y animación
    void update();

    // Establece el frame actual de la animación
    void setCurrentFrame(Uint8 index, Uint8 num);

    // Establece el valor del contador
    void setAnimationCounter(Uint8 index, Uint16 num);

    // Establece el rectangulo para un frame de una animación
    void setAnimationFrames(Uint8 index, Uint8 frame, int x, int y, int w, int h);

    // Establece el rectangulo para un frame de una animación
    void setAnimationFrames(Uint8 index, Uint8 frame, SDL_Rect rect);

    // Establece la velocidad de una animación
    void setAnimationSpeed(Uint8 index, Uint8 speed);

    // Establece el numero de frames de una animación
    void setAnimationNumFrames(Uint8 index, Uint8 num);

    // Establece si la animación se reproduce en bucle
    void setAnimationLoop(Uint8 index, bool loop);

    // Devuelve el rectangulo de una animación y frame concreto
    SDL_Rect getAnimationClip(Uint8 index, Uint8 frame);

    // Establece la animación actual
    void AnimatedSprite::setCurrentAnimation(Uint8 index);

    // Obtiene la animación actual
    Uint8 AnimatedSprite::getCurrentAnimation();

private:
    struct sAnimation
    {
        SDL_Rect frame[MAX_FRAMES]; // Vector con los rectangulos de cada frame de la animación
        Uint8 numFrames;            // Cantidad de frames de la animacion
        Uint8 speed;                // Velocidad de la animación
        Uint8 currentFrame;         // Frame actual
        Uint16 counter;             // Contador
        bool loop;                  // Indica si la animación se reproduce en bucle
    };

    sAnimation mAnimation[MAX_ANIMATIONS]; // Vector con las animaciones
    Uint8 mCurrentAnimation;               // Animación actual;
};

#endif
